import React, { Component } from 'react'
import ReactDOM from 'react-dom'

import Screens from "screen"
import "../global.js"

import {init_store, receive} from 'dudy-flow'

init_store()



@receive("counter", (state = {v : 1}, action) => {
  switch(action.type) {
    case "ADD" :
      return {v : state.v + 1}
    case "SUB" :
      return {v : state.v - 1}
  }
  return state 
})
class App extends Component {

  constructor() {
    super()
    this.state = { store: null }
  }

  

  render() {
    return (
      <div>
       {this.props.counter.v} 
       <button onClick={() => store.dispatch({type : "ADD"})}>+</button>
       <button onClick={() => store.dispatch("SUB")}>-</button>
      </div>
    )
  }
}


ReactDOM.render(
  <App />,
  document.getElementById("app"))
