"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _storage = require("./storage");

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Store = function () {
  function Store(options) {
    var _this = this;

    _classCallCheck(this, Store);

    this.__set_state = function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(nextState) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(_this.state !== nextState)) {
                  _context.next = 6;
                  break;
                }

                if (!_this.persist) {
                  _context.next = 4;
                  break;
                }

                _context.next = 4;
                return (0, _storage.set)(_this.topic, JSON.stringify(nextState));

              case 4:

                _this.state = nextState;
                _this.store_handlers.forEach(function (h) {
                  h(_this.state);
                });

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, _this);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();

    this.topic = 'dudy-' + options.topic;
    this.initialState = options.initialState;
    this.persist = options.persist || false;
    this.handlers = [];
    this.store_handlers = [];
    this.__init_promise = this.init().then(function () {
      return new Promise(function (resolve, reject) {
        if (!_this.state) {
          // 从persist中没有获得初始值，通过reducer获取
          var nextState = _this.state || {};
          _this.handlers.forEach(function (h) {
            var next = h(_this.state, {});
            if (next) {
              nextState = _extends({}, nextState, next);
            }
          });
          _this.state = nextState;
        }
        resolve();
      });
    });
  }

  /**
   * 监听store内容变化
   * @param  handler 
   */


  _createClass(Store, [{
    key: "subscribe",
    value: function subscribe(handler) {
      var _this2 = this;

      this.store_handlers.push(handler);
      return function () {
        _this2.store_handlers = _this2.store_handlers.filter(function (x) {
          return x !== handler;
        });
      };
    }

    /**
     * 定义store中的内容，如何到达下一个状态
     * 类似redux的reducer
     * @param handler 
     */

  }, {
    key: "next",
    value: function next(handler) {
      var _this3 = this;

      this.handlers.push(handler);

      // return unsubscribe
      return function () {
        _this3.handlers = _this3.handlers.filter(function (x) {
          return x !== handler;
        });
      };
    }

    /**
     * 初始化store
     */

  }, {
    key: "init",
    value: function () {
      var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
        var str;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.state = this.initialState;

                if (!this.persist) {
                  _context2.next = 6;
                  break;
                }

                _context2.next = 4;
                return (0, _storage.get)(this.topic);

              case 4:
                str = _context2.sent;

                if (str) {
                  try {
                    this.state = JSON.parse(str);
                  } catch (ex) {
                    this.state = this.initialState;
                  }
                }

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function init() {
        return _ref2.apply(this, arguments);
      }

      return init;
    }()

    /**
     * 获取状态
     */

  }, {
    key: "get_state",
    value: function get_state() {
      return this.state;
    }

    /**
     * 设置状态，内部使用
     */

  }, {
    key: "get",
    value: function get(name) {
      if (this.state) {
        return this.state[name];
      }
    }
  }], [{
    key: "config",


    /**
     * 配置一个store
     */
    value: function config(options) {
      var __store = new Store(options);
      global.store.push(options.topic, __store);
    }
  }]);

  return Store;
}();

module.exports = Store;