'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Store = require('./Store');

var _Store2 = _interopRequireDefault(_Store);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * 方便用户使用，将所有的store集中管理
 */
var StoreManager = function () {
  function StoreManager() {
    var _this = this;

    _classCallCheck(this, StoreManager);

    this.source = function (trigger, eventMapper) {
      trigger(function () {
        var action = eventMapper.apply(null, arguments);
        store.dispatch(action);
      });
    };

    this.dispatch = function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(action) {
        var _loop, key;

        return regeneratorRuntime.wrap(function _callee$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (typeof action === 'string') {
                  action = { type: action };
                }

                _loop = regeneratorRuntime.mark(function _loop(key) {
                  var store, nextState;
                  return regeneratorRuntime.wrap(function _loop$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          store = _this.stores[key];
                          nextState = store.get_state();

                          store.handlers.forEach(function (h) {
                            var next = h(nextState, action);
                            if (next) {
                              nextState = _extends({}, nextState, next);
                            }
                          });

                          _context.next = 5;
                          return store.__set_state(nextState);

                        case 5:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _loop, _this);
                });
                _context2.t0 = regeneratorRuntime.keys(_this.stores);

              case 3:
                if ((_context2.t1 = _context2.t0()).done) {
                  _context2.next = 8;
                  break;
                }

                key = _context2.t1.value;
                return _context2.delegateYield(_loop(key), 't2', 6);

              case 6:
                _context2.next = 3;
                break;

              case 8:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee, _this);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();

    this.stores = {};
  }

  /**
   * 将一个事件源变成触发器
   * 每次事件发生时调用dispatch
   */


  _createClass(StoreManager, [{
    key: 'push',
    value: function push(topic, proxy) {
      this.stores[topic] = proxy;
    }

    /**
     * 获取store
     * 如果没有就创建
     */

  }, {
    key: 'get',
    value: function get(topic) {
      if (typeof topic !== 'string') {
        return;
      }
      if (topic in this.stores) {
        return this.stores[topic];
      }

      _Store2.default.config({
        topic: topic
      });
      return this.stores[topic];
    }
  }]);

  return StoreManager;
}();

/**
 * 保证StoreManager是一个单例
 */


function init() {
  var storeMgr = new StoreManager();

  global.store = storeMgr;
  if (typeof window !== 'undefined') {
    window.store = global.store;
  }
  return StoreManager;
}

module.exports = init();