import "babel-polyfill"

import {assert, should} from 'chai'

should()


const wait = (time) => {
  return new Promise( (resolve, reject) => {
    setTimeout ( () => {
      resolve()
    }, time)
  })
}

describe("语法测试", () => {

  beforeEach( () => {
    const { init_store } = require("../src/index")
    global.window = {
      localStorage: {}
    }

    init_store(window.localStorage)
  })

  it("测试创建store/dispatch事件", (done) => {
    assert.isNotNull(store)
    store.get('user').next( (state, action) => {
      switch(action.type) {
        case "TEST" :
          return {tested : true}
      }
    })

    const promise = store.dispatch({type : "TEST"})
    promise.should.have.property('then') 

    promise.then( () => {
      assert.equal(store.get('user').get_state().tested, true)
      done()
    })
  })

  it("测试初始值-和值的迭代", async () => {
    
    store.get('counter').next((state = {v : 0}, action) => {
      switch (action.type) {
        case "ADD":
          return { v : state.v + 1}
      }
      return state 
    })


    await wait()
    assert.equal(store.get("counter").state.v, 0)

    store.dispatch({type : "ADD"})
    await wait()
    assert.equal(store.get('counter').state.v , 1)

    store.dispatch({type : "ADD"})
    await wait()
    assert.equal(store.get('counter').state.v , 2)

    store.dispatch({type : "ADD"})
    await wait()
    assert.equal(store.get('counter').state.v , 3)
  })


})

