import React, {Component} from 'react'
import ReactDOM from 'react-dom'
import {receive, init_store} from '../src' 
import {JSDOM} from "jsdom"
import ReactTestUtils from 'react-dom/test-utils'
import {assert} from 'chai'

require('fbjs/lib/ExecutionEnvironment').canUseDOM = true


function wait() {
  return new Promise( (resolve, reject) => {
    setTimeout(function () {
      resolve()
    });

  })
}


describe('receive高阶组件测试', function() {

    beforeEach(function(){

      global.window = new JSDOM(`<html><body><div id='app'></div></body></html>`).window
      global.document = window.document
      global.navigator = global.window.navigator;
      global.ele = document.querySelector('#app')
      window.localStorage = {}

      init_store()

      @receive("test")
      class TestComponent extends Component {

        render() {
          if(this.props.test.tested) {
            return <div className='tested'>tested</div>
          }
          else {
            return <div className='not-tested'>not-tested</div>
          }
        }
      }

      global.TestComponent = TestComponent


      global.reactEle = document.querySelector("#app")

    })

    afterEach(function(done) {
        ReactDOM.unmountComponentAtNode(ele) // Assuming mounted to document.body
        document.body.innerHTML = ""                // Just to be sure :-P
        setTimeout(done)
    })


    it("测试react组件状态变化", async () => {

      store.get('test').next( (state, action) => {
        switch(action.type){
          case "TEST":
            return { tested: true }
        }
      })
      ReactDOM.render(<TestComponent />, ele)
      await wait()
      let elements = document.querySelector(".not-tested")
      assert.notEqual(null, elements)
      store.dispatch("TEST")

      await wait()
      elements = document.querySelector(".tested")
      assert.notEqual(null, elements)
    })


})